/*  "blkio.scm" WB-tree File Based Associative String Data Base System. */
/*  Copyright (C) 1991, 1992, 1993, 2000, 2003 Free Software Foundation, Inc. */
/*  */
/*  This program is free software: you can redistribute it and/or modify */
/*  it under the terms of the GNU Lesser General Public License as */
/*  published by the Free Software Foundation, either version 3 of the */
/*  License, or (at your option) any later version. */
/*  */
/*  This program is distributed in the hope that it will be useful, but */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*  Lesser General Public License for more details. */
/*  */
/*  You should have received a copy of the GNU Lesser General Public */
/*  License along with this program.  If not, see */
/*  <http://www.gnu.org/licenses/>. */

/*  routines in this file return pass/fail (#t/#f) */




package wb;

import static wb.Stats.*;
import static wb.Wbdefs.*;
import static wb.Wbsys.*;
import static wb.Blk.*;
import static wb.BooleanMethods.*;
public class Blkio {


public static int ioDiag = 0;


public static void blkio_Init()
{
  
  return;
}


public static java.io.RandomAccessFile blkio_CreateFile(String name,int bsiz)
{
  return openOutputFile(name);
}


public static java.io.RandomAccessFile blkio_OpenModifyFile(String name,int bsiz)
{
  return openIoFile(name);
}


public static java.io.RandomAccessFile blkio_OpenReadOnlyFile(String name,int bsiz)
{
  return openInputFile(name);
}


public static int blkio_FileClose(java.io.RandomAccessFile file)
{
  return closePort(file);
}


public static int blkio_Read(java.io.RandomAccessFile file,byte []blk,int bsiz,int blknum)
{
  filePosition(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytesRead(blk, 0, bsiz, file)))
    {
      if (a2b(ioDiag))
	dprintf("rd:"+(1+((blk_Level(blk))-(leaf)))+""+""+" "+(blk_Typ(blk))+"\n");
      if (blk_Typ_P(blk, frlTyp))
	{
	  readFlCt = (readFlCt)+1;
	}
      else readCt = (readCt)+1;
      return 1;
    }
  else {
    dprintf(">>>>ERROR<<<<  couldn\'t read blk "+(blknum)+"\n");
    return 0;
  }
}


public static int blkio_Write(java.io.RandomAccessFile file,byte []blk,int bsiz,int blknum)
{
  filePosition(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytesWrite(blk, 0, bsiz, file)))
    {
      if (a2b(ioDiag))
	dprintf("wr:"+(1+((blk_Level(blk))-(leaf)))+""+""+" "+(blk_Typ(blk))+"\n");
      if (blk_Typ_P(blk, frlTyp))
	{
	  writeFlCt = (writeFlCt)+1;
	}
      else writeCt = (writeCt)+1;
      return 1;
    }
  else {
    dprintf(">>>>ERROR<<<<  couldn\'t write blk "+(blknum)+"\n");
    return 0;
  }
}


public static int blkio_FileExtend(java.io.RandomAccessFile file,byte []blk,int bsiz,int blknum)
{
  filePosition(file, (bsiz)*(blknum));
  if ((bsiz)==(subbytesWrite(blk, 0, bsiz, file)))
    {
      if (a2b(ioDiag))
	dprintf("Extending file "+(((flcLen)/2)+1)+" blks\n");
      return 1;
    }
  else {
    dprintf(">>>>ERROR<<<<  couldn\'t extend file "+(blknum)+"\n");
    return 0;
  }
}

}
