/* WB-tree File Based Associative String Data Base System.
 * Copyright (C) 1991, 1992, 1993, 2000, 2003 Free Software Foundation, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#ifdef __STDC__
# define STDC_INCLUDES
#endif
#ifdef __TURBOC__
# define MSDOS
#endif
#ifdef __MINGW32__
# define MSDOS
# ifndef max
#  define max(a,b)		(a<b ? b : a)
#  define min(a,b)		(a>b ? b : a)
# endif
#endif
#ifdef _MSC_VER
# define MSDOS
#endif
#ifdef MSDOS
# define STDC_INCLUDES
#endif
#ifdef VMS
# define STDC_INCLUDES
#endif

#ifdef STDC_INCLUDES
# include <stdlib.h>
# include <string.h>
#else
	unsigned char *malloc();
	unsigned char *realloc();
#endif

#ifdef MSDOS
# include <sys\types.h>
# include <sys\stat.h>
# include <io.h>
# include <fcntl.h>
# define open_input_file(name) (open(name,O_BINARY | O_RDONLY))
# define open_output_file(name) (open(name,O_BINARY | O_WRONLY | O_CREAT, S_IWRITE | S_IREAD))
# define open_io_file(name) (open(name,O_BINARY | O_RDWR))
#else /* MSDOS */
/* #include <sys/stat.h> */
# define max(a,b)		(a<b ? b : a)
# define min(a,b)		(a>b ? b : a)
extern int errno;
# include <fcntl.h>
# define open_input_file(name) (open(name, O_RDONLY))
# define open_output_file(name) (open(name, O_WRONLY | O_CREAT | O_TRUNC, 0666))
# define open_io_file(name) (open(name, O_RDWR))
#endif

#include <time.h>

#define substring_move_left(src,start,end,dst,dstart) (memmove(&dst[dstart],&src[start],(end)-(start)))
#define substring_move_right substring_move_left
#define substring_move(src,start,end,dst,dstart) (memcpy(&dst[dstart],&src[start],(end)-(start)))

/* these are only used in blkio.scm, but are here for their SCM equivalents. */

#ifdef _MSC_VER
# define open _open
# define close _close
# define read _read
# define write _write
# define lseek _lseek
#else
# include <unistd.h>
#endif

#define file_position(fildes,offset) (lseek(fildes,offset,SEEK_SET))
#define subbytes_write(buf,start,end,fildes) (write(fildes,&((char *)buf)[start],end-start))
#define subbytes_read(buf,start,end,fildes) (read(fildes,&((char *)buf)[start],end-start))

#define close_port(fildes) (close(fildes))
#define output_port_P(fildes) ((fildes)>=0)
#define input_port_P(fildes) ((fildes)>=0)

#define j_zero 0
#define j_one  1
#define j_null NULL

typedef struct slck {
  struct slck *NEXT;
  int FLG;
  int NAME;
} LCK;

extern LCK *last_lck;

LCK *make_lck();
int try_lck_P();
void lck();
void unlck();
void check_lcks();

typedef struct entry {
  struct entry *NEXT;
  long ID;
  unsigned char *BLK;
  int TAG, AGE, DTY, PUS, ACC, REF, SEG;
} ENTRY;

ENTRY *make_ent();

typedef int (*int_function)();

#define ent_tag(ent) ((ent)->TAG)
#define ent_next(ent) ((ent)->NEXT)
#define ent_seg(ent) ((ent)->SEG)
#define ent_id(ent) ((ent)->ID)
#define ent_blk(ent) ((ent)->BLK)
#define ent_age(ent) ((ent)->AGE)
#define ent_dty_P(ent) ((ent)->DTY)
#define ent_pus(ent) ((ent->PUS))
#define ent_acc(ent) ((ent)->ACC)
#define ent_ref(ent) ((ent)->REF)

#define ent_set_tag(ent, tag) {(ent)->TAG = tag;}
#define ent_set_next(ent, next) {(ent)->NEXT = next;}
#define ent_set_seg(ent, seg) {(ent)->SEG = seg;}
#define ent_set_id(ent, num) {(ent)->ID = num;}
#define ent_set_age(ent, age) {(ent)->AGE = age;}
#define ent_set_dty(ent, dty) {(ent)->DTY = dty;}
#define ent_set_pus(ent, pus) {(ent)->PUS = pus;}
#define ent_set_acc(ent, acc) {(ent)->ACC = acc;}
#define ent_set_ref(ent, ref) {(ent)->REF = ref;}

typedef struct {
  int SEG, TYP;
  long ID, LAST;
  int WCB, SPARE;
} HAND;

HAND *make_han();

#define han_id(han) (((HAND *)(han))->ID)
#define han_seg(han) (((HAND *)(han))->SEG)
#define han_typ(han) (((HAND *)(han))->TYP)
#define han_last(han) (((HAND *)(han))->LAST)
#define han_wcb(han) (((HAND *)(han))->WCB)

#define han_set_num(han,num) {((HAND *)(han))->ID = num;}
#define han_set_seg(han,seg) {((HAND *)(han))->SEG = seg;}
#define han_set_typ(han,typ) {((HAND *)(han))->TYP = typ;}
#define han_set_last(han,last) {((HAND *)(han))->LAST = last;}
#define han_set_wcb(han,wcb) {((HAND *)(han))->WCB = wcb;}

typedef struct {
  int PORT, BSIZ;
  long USED;
  unsigned char *STRN;
  HAND RT_HAN, FL_HAN;
  LCK FLCK;
  LCK FFCK;
  int FLC_LEN;
  long *FLC;
} SEGD;

extern SEGD segd_tab[];

#define segd_port(segd) ((segd).PORT)
#define segd_bsiz(segd) ((segd).BSIZ)
#define segd_used(segd) ((segd).USED)
#define segd_str(segd) ((segd).STRN)
#define segd_rt_han(segd) (&((segd).RT_HAN))
#define segd_fl_han(segd) (&((segd).FL_HAN))
#define segd_lck(segd) (&((segd).FLCK))
#define segd_fck(segd) (&((segd).FFCK))
#define segd_flc_len(segd) ((segd).FLC_LEN)
#define segd_flc(segd) ((segd).FLC)

#define segd_set_port(segd,port) {(segd).PORT = port;}
#define segd_set_bsiz(segd,bsiz) {(segd).BSIZ = bsiz;}
#define segd_set_used(segd,used) {(segd).USED = used;}
#define segd_set_str(segd,strn) {(segd).STRN = strn;}
#define segd_set_flc_len(segd,len) {(segd).FLC_LEN = len;}
#define segd_set_flc(segd,flc) {(segd).FLC = flc;}

/*  The SEG (segment) structure */

#define seg_port(seg) (segd_port(segd_tab[seg]))
#define seg_bsiz(seg) (segd_bsiz(segd_tab[seg]))
#define seg_used(seg) (segd_used(segd_tab[seg]))
#define seg_str(seg) (segd_str(segd_tab[seg]))
#define seg_rt_han(seg) (segd_rt_han(segd_tab[seg]))
#define seg_fl_han(seg) (segd_fl_han(segd_tab[seg]))
#define seg_lck(seg) (segd_lck(segd_tab[seg]))
#define seg_fck(seg) (segd_fck(segd_tab[seg]))
#define seg_flc_len(seg) (segd_flc_len(segd_tab[seg]))
#define seg_flc(seg) (segd_flc(segd_tab[seg]))

#define seg_set_port(seg, port) {segd_set_port(segd_tab[seg], port);}
#define seg_set_bsiz(seg, bsiz) {segd_set_bsiz(segd_tab[seg], bsiz);}
#define seg_set_used(seg, used) {segd_set_used(segd_tab[seg], used);}
#define seg_set_str(seg, str) {segd_set_str(segd_tab[seg], str);}
#define seg_set_flc_len(seg, flc_len) {segd_set_flc_len(segd_tab[seg], flc_len);}
#define seg_set_flc(seg, flc) {segd_set_flc(segd_tab[seg], flc);}

/*  BLK parameters */

/*  The IDs are 4 byte numbers identifying this block, the root of */
/*  this tree, and the next in the chain. */

#define blk_id_pos 0
#define blk_top_id_pos 4
#define blk_nxt_id_pos 8
#define blk_time_pos 0xc
/*  blk-end-pos is position (stored in 2 bytes) of first free byte */
#define blk_end_pos 0x10
#define blk_level_pos 0x12
#define blk_typ_pos 0x13
#define blk_data_start 0x14

#define blk_id(blk) (str2long(blk, blk_id_pos))
#define blk_top_id(blk) (str2long(blk, blk_top_id_pos))
#define blk_nxt_id(blk) (str2long(blk, blk_nxt_id_pos))
#define blk_time(blk) (str2long(blk, blk_time_pos))
#define blk_end(blk) (str2short(blk, blk_end_pos))
#define blk_level(b) ((((unsigned char*)(b))[blk_level_pos]))
#define blk_typ(b) ((((unsigned char*)(b))[blk_typ_pos]))
#define blk_typ_P(b, typ) (((((unsigned char*)(b))[blk_typ_pos]))==(typ))

#define blk_set_id(blk, id) {long2str(blk, blk_id_pos, id);}
#define blk_set_top_id(blk, id) {long2str(blk, blk_top_id_pos, id);}
#define blk_set_nxt_id(blk, id) {long2str(blk, blk_nxt_id_pos, id);}
#define blk_set_time(blk, tim) {long2str(blk, blk_time_pos, tim);}
#define blk_set_end(blk, pos) {short2str(blk, blk_end_pos, pos);}
#define blk_set_level(b, level) {b[blk_level_pos] = level;}
#define blk_set_typ(b, typ) {b[blk_typ_pos] = typ;}

/*  Routines for finding the appropriate BLK for an operation. */
/*  PACKETs used to return multiple values from chain-find. */
/*  and various other operations */
#define pkt_size 6

#define pkt_match_type(p) (p[0])
#define pkt_match_pos(p) (p[1])
#define pkt_key_pos(p) (p[2])
#define pkt_prev_match_pos(p) (p[3])
#define pkt_blk_to_cache(p) (p[4])
#define pkt_success_code(p) (p[5])

#define pkt_set_match_type(p, v) {p[0] = v;}
#define pkt_set_match_pos(p, v) {p[1] = v;}
#define pkt_set_key_pos(p, v) {p[2] = v;}
#define pkt_set_prev_match_pos(p, v) {p[3] = v;}
#define pkt_set_blk_to_cache(p, v) {p[4] = v;}
#define pkt_set_success_code(p, v) {p[5] = v;}

#define pkt_pack(p, type, b_pos, k_pos, p_pos) {pkt_set_match_type(p, type);pkt_set_match_pos(p, b_pos);pkt_set_key_pos(p, k_pos);pkt_set_prev_match_pos(p, p_pos);}

/*  Aliased function names for SCAN */
#define pkt_skey_count pkt_match_pos
#define pkt_set_skey_count pkt_set_match_pos
#define pkt_skey_len pkt_key_pos
#define pkt_set_skey_len pkt_set_key_pos


#include <stdio.h>

extern FILE *diagout;
#define dprintf(DaRgS) (fprintf DaRgS)

#ifndef SCM_EXPORT
# define SCM_EXPORT extern
#endif

#ifndef P
# ifdef __STDC__
#  ifndef __HIGHC__
#   define USE_ANSI_PROTOTYPES
#  endif
# endif
# ifdef __sgi__
#  define USE_ANSI_PROTOTYPES
# endif

# ifdef USE_ANSI_PROTOTYPES
#  define P(s) s
# else
#  define P(s) ()
# endif
#endif

#include "wbdefs.h"
#include "ents.h"
#include "blink.h"
#include "handle.h"
#include "segs.h"
#include "prev.h"
#include "del.h"
#include "stats.h"
#include "blkio.h"
#include "scan.h"

ENTRY *ent_make_ent(int tag);
